############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package KeysManager;no warnings;(my $__maxRotatedFiles=(0x11ac+ 3625-0x1fcf));
sub __getBackupFileName{(my $name=shift (@_));($name.=
"\x2e\x62\x61\x63\x6b\x75\x70");if ((not (Common::NXFile::fileExists ($name)))){
return ($name);}(my $number=(0x1099+ 2091-0x18c2));while (($number<=
$__maxRotatedFiles)){if ((not (Common::NXFile::fileExists (($name.$number))))){
return (($name.$number));}($number+=(0x00d4+ 4872-0x13db));}($number=
(0x18b8+ 2893-0x2404));(my $oldestFile=$name);(my $oldestCTime=
Common::NXCore::NXFileCTime ($name));while (($number<=$__maxRotatedFiles)){(my $cTime
=Common::NXCore::NXFileCTime (($name.$number)));if (($oldestCTime>$cTime)){(
$oldestFile=($name.$number));($oldestCTime=$cTime);}($number+=
(0x0831+ 6525-0x21ad));}return ($oldestFile);}sub __backupKey{(my $file=shift (
@_));(my $backup=__getBackupFileName ($file));if (Common::NXFile::fileExists (
$file)){(my ($ret,$error)=Common::NXCore::copyFile ($file,$backup));if (($error 
ne (""))){Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x126b+ 561-0x149b));}else{
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX ($backup);}}return (
(0x0545+ 2698-0x0fcf));}sub __createRestore{(my $file=shift (@_));if ((not (
Common::NXFile::isExists ($file)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x73\x74\x6f\x72\x65\x20\x66\x69\x6c\x65\x2e\x20"
.$file)."\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));
return ((0x0abc+ 6159-0x22cb));}(my $restore=($file.
"\x2e\x72\x65\x73\x74\x6f\x72\x65"));if (Common::NXFile::isExists ($restore)){
Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x73\x74\x6f\x72\x65\x20\x66\x69\x6c\x65\x2e\x20"
.$restore)."\x20\x65\x78\x69\x73\x74\x73\x2e"));return ((0x120f+ 3268-0x1ed3));}
if (Common::NXFile::fileExists ($file)){(my ($ret,$error)=
Common::NXCore::copyFile ($file,$restore));if (($error ne (""))){Logger::warning
 ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x73\x74\x6f\x72\x65\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x0202+ 430-0x03af));}else{
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($restore);}}return
 ((0x03bb+ 4042-0x1385));}sub __createDefault{(my $file=shift (@_));(my $default
=shift (@_));if (Common::NXFile::fileExists ($default)){return (
(0x0ef2+ 3617-0x1d13));}if (Common::NXFile::fileExists ($file)){(my ($ret,$error
)=Common::NXCore::copyFile ($file,$default));if (($error ne (""))){
Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x66\x61\x75\x6c\x74\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x12a8+ 4307-0x237a));}else{
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($default);}}return
 ((0x0f85+ 451-0x1148));}sub backup{if ((__backupKey (NXPaths::getNodePublicKeys
 ())==(0x048c+ 8149-0x2460))){return ((0x09b7+ 1677-0x1043));}if ((__backupKey (
NXPaths::getUserDefaultRSAPublicKeyPath ())==(0x0280+ 2877-0x0dbc))){return (
(0x0dc9+ 4928-0x2108));}if ((__backupKey (NXPaths::getClientRSAPrivateKey ())==
(0x18e8+ 2234-0x21a1))){return ((0x0deb+ 2941-0x1967));}if ((__backupKey (
NXPaths::getClientRSADefaultPrivateKey ())==(0x0755+ 5169-0x1b85))){return (
(0x00ad+ 7051-0x1c37));}if ((__backupKey (NXPaths::getClientDSADefaultPrivateKey
 ())==(0x1641+ 3359-0x235f))){return ((0x159b+ 1906-0x1d0c));}if ((
__createRestore (NXPaths::getClientRSAPrivateKey ())==(0x157a+ 3386-0x22b3))){
return ((0x02ba+ 7417-0x1fb2));}return ((0x0ed7+ 2921-0x1a40));}sub 
__generateRSAKeys{(my $public=NXPaths::getUserNewRSAPublicKey ());(my $private=
NXPaths::getUserNewRSAPrivateKey ());return (__generateKeys ($public,$private,
"\x72\x73\x61"));}sub __generateKeys{(my $publicKeyFileName=shift (@_));(my $privateKeyFileName
=shift (@_));(my $algorithm=shift (@_));(my (@command)=());(my (@options)=());(my $selinuxenabled
=NXTools::getUnixCommandPath (
"\x73\x65\x6c\x69\x6e\x75\x78\x65\x6e\x61\x62\x6c\x65\x64"));if (
Common::NXFile::isExists ($selinuxenabled)){(@command=$selinuxenabled);(my $runcon
=NXTools::getUnixCommandPath ("\x72\x75\x6e\x63\x6f\x6e"));(my ($cmd_err,
$cmd_out,$exit_value)=main::run_command ((\@command),(\@options)));if ((
$exit_value==(0x06c1+ 149-0x0756))){if (Common::NXFile::isExists ($runcon)){push
 (@command,$runcon,"\x2d\x75","\x72\x6f\x6f\x74","\x2d\x72",
"\x73\x79\x73\x74\x65\x6d\x5f\x72","\x2d\x74","\x69\x6e\x69\x74\x72\x63\x5f\x74"
,"\x2d\x2d");}}else{Logger::debug2 (
"\x53\x65\x6c\x69\x6e\x75\x78\x20\x69\x73\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x20\x69\x6e\x20\x74\x68\x69\x73\x20\x73\x79\x73\x74\x65\x6d"
);}}(@command=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);push (@command,
"\x2d\x6b",$privateKeyFileName,"\x2d\x74",$algorithm,"\x2d\x70",
$publicKeyFileName);push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".NXPaths::getUserNXHomeDir ()));(my ($cmdErr,$cmdOut,
$exitValue)=main::nxRunCommand ((\@command),(\@options)));if (($exitValue!=
(0x145a+ 4258-0x24fc))){Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x6e\x65\x72\x61\x74\x65\x20".$algorithm).
"\x20\x6b\x65\x79\x20").$exitValue).
"\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x68\x65\x63\x6b\x20\x74\x68\x65\x20\x27\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x27\x20\x66\x69\x6c\x65\x20\x66\x6f\x72\x20\x70\x6f\x73\x73\x69\x62\x6c\x65\x20\x69\x73\x73\x75\x65\x73\x2e"
));}return ($exitValue);}sub __getKeysFromFile{(my $keyFile=shift (@_));if ((not
 (Common::NXFile::isExists ($keyFile)))){return (undef);}(my (@keyLists)=());(my $fileFH
=Common::NXCore::nxopen ($keyFile,$NXBits::O_RDONLY,(0x0a95+ 5025-0x1e36)));if (
(not (defined ($fileFH)))){(my $error=libnxh::NXGetErrorName ());Logger::error (
((("\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27".
$keyFile)."\x27\x3a\x20").$error));return (undef);}while (
Common::NXCore::nxreadLine ($fileFH,(\$_))){($_=~ s/\r//g );chomp ($_);push (
@keyLists,$_);}Common::NXCore::nxclose ($fileFH);return (@keyLists);}sub 
__addPrefix{(my $file=shift (@_));(my (@keys)=__getKeysFromFile ($file));if ((
not (defined (@keys)))){return ((0x0139+ 3306-0x0e22));}(my $fh=
Common::NXCore::nxopen ($file,$NXBits::O_WRONLY,(0x02d3+ 6768-0x1d43)));if ((not
 (defined ($fh)))){(my $error=libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$file).
"\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x2e\x20").$error)."\x2e"));return (
(0x0ac6+ 4272-0x1b75));}foreach my $key (@keys){($key=__getKeyWithPrefix ($key))
;if ((Common::NXCore::nxwrite ($fh,$key)==(-(0x1a24+ 1062-0x1e49)))){(my $error=
libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x3a\x20").$error)."\x2e"));Common::NXCore::nxclose ($fh);return (
(0x00c5+ 4925-0x1401));}}Common::NXCore::nxclose ($fh);return (
(0x0dd6+ 777-0x10df));}sub __getKeyWithPrefix{(my $key=shift (@_));chomp ($key);
chomp ($key);(my $keyWithPrefix.=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c");
(my $path=NXPaths::getServerLaunchPath ());($keyWithPrefix.=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$path).
"\x20\x2d\x2d\x6c\x6f\x67\x69\x6e\x22\x20"));($keyWithPrefix.=$key);(
$keyWithPrefix.="\x0a");return ($keyWithPrefix);}sub generate{if (
isRSASuportedByServerConfig ()){if ((__generateRSAKeys ()>(0x1ca7+ 1954-0x2449))
){return ((0x1182+ 3196-0x1dfd));}if ((__addPrefix (
NXPaths::getUserNewRSAPublicKey ())==(0x0bcf+ 1397-0x1143))){return (
(0x01a1+ 1352-0x06e8));}}return ((0x0440+ 5054-0x17fe));}sub 
__changeRSAPublicKey{(my $file=NXPaths::getNodePublicKeys ());(my $oldKey=
NXPaths::getUserDefaultRSAPublicKeyPath ());if (Common::NXFile::isExists (
$oldKey)){if ((__removePublicKey ($file,$oldKey)==(0x05fb+ 2909-0x1157))){return
 ((0x0377+ 143-0x0405));}}(my $newKey=NXPaths::getUserNewRSAPublicKey ());if ((
__addPublicKey ($file,$newKey)==(0x009a+ 5644-0x16a5))){return (
(0x03ca+ 8584-0x2551));}if ((__moveKey ($newKey,$oldKey)==(0x021b+ 555-0x0445)))
{return ((0x058b+ 2094-0x0db8));}return ((0x1121+ 4007-0x20c8));}sub 
__removePublicKey{(my $file=shift (@_));(my $oldKeyFile=shift (@_));(my (
@oldKeys)=__getKeysFromFile ($oldKeyFile));if ((not (defined (@oldKeys)))){
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x6c\x64\x20\x6b\x65\x79\x73\x20\x66\x6f\x72\x6d\x20\x66\x69\x6c\x65\x20"
.$oldKeyFile)."\x2e"));return ((0x0a29+ 5424-0x1f58));}(my (@oldKeys)=
__getKeysFromFile ($oldKeyFile));foreach my $key (@oldKeys){__removePrefix ((
\$key));}foreach my $key (@oldKeys){if ((removeKeyFromFile ($key,$file,
"\x53\x53\x48")==(0x0fe1+ 1846-0x1716))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x6f\x6c\x64\x20\x6b\x65\x79\x20\x66\x6f\x72\x6d\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e"));return ((0x1532+ 4224-0x25b1));}}return ((0x0056+ 1607-0x069d))
;}sub __removePrefix{(my $ref_key=shift (@_));if (($$ref_key=~ /(.*) (ssh-.*) (.*)/ )
){(my $type=$2);(my $value=$3);Logger::debug (((
"\x52\x65\x6d\x6f\x76\x65\x64\x20\x70\x72\x65\x66\x69\x78\x3a\x20".$1)."\x2e"));
($$ref_key=(($type."\x20").$value));}}sub __addPublicKey{(my $file=shift (@_));(my $newKeyFile
=shift (@_));(my (@newKeys)=__getKeysFromFile ($newKeyFile));if ((not (defined (
@newKeys)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6e\x65\x77\x20\x6b\x65\x79\x73\x20\x66\x6f\x72\x6d\x20\x66\x69\x6c\x65\x20"
.$newKeyFile)."\x2e"));return ((0x0cff+ 4661-0x1f33));}(my $fh=
Common::NXCore::nxopen ($file,(($NXBits::O_CREAT+$NXBits::O_WRONLY)+
$NXBits::O_APPEND),$NXBits::UserReadWrite));if ((not (defined ($fh)))){(my $error
=libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$file).
"\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x2e\x20").$error)."\x2e"));return (
(0x0005+ 2509-0x09d1));}foreach my $key (@newKeys){if ((Common::NXCore::nxwrite 
($fh,($key."\x0a"))==(-(0x0288+ 8223-0x22a6)))){(my $error=
libnxh::NXGetErrorName ());Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x3a\x20").$error)."\x2e"));Common::NXCore::nxclose ($fh);return (
(0x16e8+ 728-0x19bf));}}Common::NXCore::nxclose ($fh);if ((
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX ($file)==(-
(0x0044+ 3932-0x0f9f)))){return ((0x22a8+  86-0x22fd));}return (
(0x0295+ 7407-0x1f84));}sub __changeRSAPrivateKey{(my $newFile=
NXPaths::getUserNewRSAPrivateKey ());(my $clientFile=
NXPaths::getClientRSAPrivateKey ());if ((__moveKey ($newFile,$clientFile)==
(0x0a09+ 2391-0x135f))){return ((0x171d+ 3195-0x2397));}return (
(0x0e13+ 5524-0x23a7));}sub __moveKey{(my $from=shift (@_));(my $to=shift (@_));
if (Common::NXFile::fileExists ($from)){if ((Common::NXCore::moveFile ($from,$to
)==(0x1228+ 4069-0x220d))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x6d\x6f\x76\x65\x20\x6b\x65\x79\x20\x66\x69\x6c\x65\x2e"
);return ((0x03ad+ 1298-0x08be));}}else{Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20".$from).
"\x2e\x20\x46\x69\x6c\x65\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"
));return ((0x00c3+ 6852-0x1b86));}return ((0x02c0+ 821-0x05f5));}sub __copyKey{
(my $from=shift (@_));(my $to=shift (@_));if (Common::NXFile::fileExists ($from)
){(my ($ret,$error)=Common::NXCore::copyFile ($from,$to));if (($error ne (""))){
Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x70\x79\x20\x73\x73\x68\x20\x70\x75\x62\x6c\x69\x63\x20\x6b\x65\x79\x20\x66\x69\x6c\x65\x2e\x20"
.$error));return ((0x19e9+ 1186-0x1e8a));}else{if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($to)==(-
(0x0185+ 6483-0x1ad7)))){Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20\x66\x69\x6c\x65\x20"
.$to)."\x2e"));return ((0x0cd5+ 4932-0x2018));}}}else{Logger::warning (((
"\x53\x6f\x75\x72\x63\x65\x20\x6b\x65\x79\x20\x66\x69\x6c\x65\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x20"
.$from)."\x2e"));return ((0x160c+ 971-0x19d6));}return ((0x1dd7+ 1945-0x2570));}
sub change{if (isRSASuportedByServerConfig ()){if ((__changeRSAPublicKey ()==
(0x0966+ 2426-0x12df))){return ((0x1988+ 3347-0x269a));}if ((
__changeRSAPrivateKey ()==(0x029f+ 144-0x032e))){return ((0x1549+ 3928-0x24a0));
}}return ((0x17f5+ 604-0x1a51));}sub __restoreRSAPublicKey{(my $file=
NXPaths::getNodePublicKeys ());(my $oldKey=
NXPaths::getUserDefaultRSAPublicKeyPath ());if (Common::NXFile::isExists (
$oldKey)){if ((__removePublicKey ($file,$oldKey)==(0x0e58+ 5126-0x225d))){return
 ((0x057a+ 2938-0x10f3));}}(my $newKey=NXPaths::getRestoreRSAPublicKey ());if ((
__addPublicKey ($file,$newKey)==(0x0537+ 5986-0x1c98))){return (
(0x0743+ 7303-0x23c9));}if ((__copyKey ($newKey,$oldKey)==(0x2526+ 261-0x262a)))
{return ((0x07bf+ 4536-0x1976));}return ((0x08f8+ 3391-0x1637));}sub 
__restoreRSAPrivateKey{(my $restoreKey=NXPaths::getClientRSARestorePrivateKey ()
);(my $clientKey=NXPaths::getClientRSAPrivateKey ());if ((__copyKey ($restoreKey
,$clientKey)==(0x0a22+ 2134-0x1277))){return ((0x079a+ 4871-0x1aa0));}return (
(0x0abc+ 3103-0x16db));}sub restore{if (isRSASuportedByServerConfig ()){if ((
__restoreRSAPublicKey ()==(0x132b+ 5017-0x26c3))){return ((0x1a21+ 2978-0x25c2))
;}if ((__restoreRSAPrivateKey ()==(0x1fb4+ 1643-0x261e))){return (
(0x19f1+ 2646-0x2446));}}return ((0x0175+ 8656-0x2345));}sub __isKeyInLine{(my $key
=shift (@_));(my $line=shift (@_));(my $protocol=shift (@_));($key=~ s/\r//g );(
$key=~ s/\n//g );chomp ($key);(my ($keyType,$keyValue)=split ( / / ,$key,
(0x13b4+ 2162-0x1c23)));($line=~ s/\r//g );($line=~ s/\n//g );chomp ($line);(my (
@lineFields)=split ( / / ,$line,(0x0550+ 6634-0x1f3a)));if (($protocol eq 
"\x53\x53\x48")){if ((($keyType eq $lineFields[(0x08b5+ 1785-0x0fac)])and (
$keyValue eq $lineFields[(0x1496+ 1242-0x196d)]))){Logger::debug (((
"\x4b\x65\x79\x20\x27".$key).
"\x27\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));return ((0x15f3+ 4270-0x26a0));}if ((($keyType eq $lineFields[
(0x1dff+ 1478-0x23c4)])and ($keyValue eq $lineFields[(0x02ea+ 5790-0x1986)]))){
Logger::debug ((("\x4b\x65\x79\x20\x27".$key).
"\x27\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));return ((0x0509+ 5465-0x1a61));}}else{if ((($keyType eq $lineFields[
(0x0123+ 8520-0x226b)])and ($keyValue eq $lineFields[(0x0afd+ 721-0x0dcd)]))){
Logger::debug ((("\x4b\x65\x79\x20\x27".$key).
"\x27\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));return ((0x1634+ 1739-0x1cfe));}}return ((0x07fa+ 369-0x096b));}sub 
__isAnyKeyInLine{(my $line=shift (@_));(my $protocol=shift (@_));($line=~ s/\r//g )
;($line=~ s/\n//g );chomp ($line);(my (@lineFields)=split ( / / ,$line,
(0x007d+ 8794-0x22d7)));if (($protocol eq "\x53\x53\x48")){if ((($lineFields[
(0x0baf+ 815-0x0edc)]ne (""))and ($lineFields[(0x0ae9+ 3064-0x16de)]ne ("")))){
Logger::debug (
"\x4b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e");
return ((0x01ef+ 3443-0x0f61));}if ((($lineFields[(0x0113+ 3237-0x0db7)]ne (""))
and ($lineFields[(0x22b6+ 960-0x2674)]ne ("")))){Logger::debug (
"\x4b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e");
return ((0x17e0+ 1692-0x1e7b));}}else{if ((($lineFields[(0x0b13+ 5096-0x1efb)]ne
 (""))and ($lineFields[(0x01f7+ 4530-0x13a8)]ne ("")))){Logger::debug (
"\x4b\x65\x79\x20\x6b\x65\x79\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
);return ((0x0b93+ 6748-0x25ee));}}return ((0x063d+ 6381-0x1f2a));}sub 
removeKeyFromFile{(my $keyToRemove=shift (@_));(my $filePath=shift (@_));(my $protocol
=shift (@_));(my $tempFilePath=(($filePath."\x2e\x74\x6d\x70\x2e").$ $));
 (my $fileFH
=Common::NXCore::nxopen ($filePath,$NXBits::O_RDONLY,(0x1313+ 4230-0x2399)));if 
((not (defined ($fileFH)))){(my $error=libnxh::NXGetErrorName ());Logger::error 
(((("\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27".
$filePath)."\x27\x3a\x20").$error));return ((0x1879+ 133-0x18fd));}(my $tempFileFH
=Common::NXCore::nxopen ($tempFilePath,(($NXBits::O_CREAT+$NXBits::O_WRONLY)+
$NXBits::O_APPEND),$NXBits::UserReadWrite));if ((not (defined ($tempFileFH)))){(my $error
=libnxh::NXGetErrorName ());Logger::error ((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x74\x65\x6d\x70\x6f\x72\x61\x72\x79\x20\x66\x69\x6c\x65\x20\x27"
.$tempFilePath)."\x27\x3a\x20").$error));return ((0x114a+ 2507-0x1b14));}while (
Common::NXCore::nxreadLine ($fileFH,(\$_))){(my $line=$_);if (__isKeyInLine (
$keyToRemove,$line,$protocol)){Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x6b\x65\x79\x20\x27".$line)."\x27\x2e"));}
else{Common::NXCore::nxwrite ($tempFileFH,$line);}}Common::NXCore::nxclose (
$tempFileFH);Common::NXCore::nxclose ($fileFH);if ((Common::NXFile::renameFile (
$tempFilePath,$filePath)==(0x0573+ 5624-0x1b6b))){return ((0x0abc+ 4991-0x1e3a))
;}if ((Common::NXFile::setOwnerShipAndPermissionsForNX ($filePath)==(-
(0x0530+ 3146-0x1179)))){return ((0x1025+ 3468-0x1db0));}return (
(0x0b36+ 2168-0x13ae));}sub isKeyInFile{(my $key=shift (@_));(my $keyFile=shift 
(@_));(my $protocol=shift (@_));(my (@listSupportedKeys)=__getKeysFromFile (
$keyFile));foreach my $line (@listSupportedKeys){if (__isKeyInLine ($key,$line,
$protocol)){Logger::debug (
"\x4b\x65\x79\x20\x69\x73\x20\x69\x6e\x20\x74\x68\x65\x20\x66\x69\x6c\x65\x2e");
return ((0x1922+ 3005-0x24de));}}Logger::debug (
"\x4b\x65\x79\x20\x69\x73\x20\x75\x6e\x69\x71\x75\x65\x2e");return (
(0x16fa+ 1630-0x1d58));}sub restorePrivateKey{(my $privateKey=
NXPaths::getClientPrivateKey ());(my $defaultPrivateKey=
NXPaths::getClientDefaultPrivateKey ());(my $restore=($privateKey.
"\x2e\x72\x65\x73\x74\x6f\x72\x65"));if (Common::NXFile::fileExists ($restore)){
copyKeyFile ($restore,$privateKey);copyKeyFile ($restore,$defaultPrivateKey);}}
sub isNotExistNodePublicKey{if (((not (Common::NXFile::isExists (
NXPaths::getNodePublicKeys ())))and (not (Common::NXFile::isExists (
NXPaths::getNXAuthorizedKeysPath ("\x6e\x78")))))){return ((0x10dd+ 3349-0x1df1)
);}if (Common::NXFile::isExists (NXPaths::getNXAuthorizedKeysPath ("\x6e\x78")))
{(my (@listSupportedKeys)=__getKeysFromFile (NXPaths::getNXAuthorizedKeysPath (
"\x6e\x78")));foreach my $line (@listSupportedKeys){if (__isAnyKeyInLine ($line,
"\x4e\x58")){Logger::debug (
"\x46\x6f\x75\x6e\x64\x20\x4e\x58\x20\x6b\x65\x79\x2e");return (
(0x0109+ 1052-0x0525));}}}if (Common::NXFile::isExists (
NXPaths::getNodePublicKeys ())){(my (@listSupportedKeys)=__getKeysFromFile (
NXPaths::getNodePublicKeys ()));foreach my $line (@listSupportedKeys){if (
__isAnyKeyInLine ($line,"\x53\x53\x48")){Logger::debug (
"\x46\x6f\x75\x6e\x64\x20\x53\x53\x48\x20\x6b\x65\x79\x2e");return (
(0x0662+ 2589-0x107f));}}}return ((0x1ff4+ 1634-0x2655));}sub 
getSupportedSSHDKeyExchangeAlgorithm{if ((
$GLOBAL::SupportedSSHDKeyExchangeAlgorithm=~ /DSA|RSA|all|DSA,RSA|RSA,DSA/ )){
return ($GLOBAL::SupportedSSHDKeyExchangeAlgorithm);}else{Logger::warning (((
"\x57\x72\x6f\x6e\x67\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x6b\x65\x79\x3a\x20\x53\x75\x70\x70\x6f\x72\x74\x65\x64\x53\x53\x48\x44\x4b\x65\x79\x45\x78\x63\x68\x61\x6e\x67\x65\x41\x6c\x67\x6f\x72\x69\x74\x68\x6d\x3a\x20"
.$GLOBAL::SupportedSSHDKeyExchangeAlgorithm).
"\x20\x75\x73\x65\x20\x61\x6c\x6c\x2e"));return ("\x61\x6c\x6c");}}sub 
isDSASuportedByServerConfig{(my $supportedKeyList=
getSupportedSSHDKeyExchangeAlgorithm ());if (($supportedKeyList=~ /DSA/ )){
return ((0x0c54+ 6513-0x25c4));}if (($supportedKeyList eq "\x61\x6c\x6c")){
return ((0x0e80+ 3619-0x1ca2));}return ((0x040d+ 6541-0x1d9a));}sub 
isRSASuportedByServerConfig{(my $supportedKeyList=
getSupportedSSHDKeyExchangeAlgorithm ());if (($supportedKeyList=~ /RSA/ )){
return ((0x10dc+ 2852-0x1bff));}if (($supportedKeyList eq "\x61\x6c\x6c")){
return ((0x1875+ 1814-0x1f8a));}return ((0x0285+ 8088-0x221d));}sub add{(my $ref_parameters
=shift (@_));($$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}=uc (
$$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}));if (($$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}eq (""))){($$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}="\x4e\x58");}unless (__getKey (
$ref_parameters)){return ((0x09d6+ 5725-0x2033));}unless (prepareKey (
$ref_parameters)){return ((0x0091+ 7663-0x1e80));}unless (setKey (
$ref_parameters)){return ((0x0c63+ 3498-0x1a0d));}NXMsg::send_response (
"\x69\x43\x4d\x44\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x41\x64\x64\x65\x64\x4f\x6b"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"});return ((0x1fc9+ 1749-0x269d));}sub 
__getKey{(my $ref_parameters=shift (@_));if (($$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"}ne (""))){unless (__getKeyFromFile (
$ref_parameters)){return ((0x1a64+ 2031-0x2253));}return ((0x0018+ 7295-0x1c96))
;}unless (__getKeyFromSTDIN ($ref_parameters)){return ((0x1bd1+ 2316-0x24dd));}
return ((0x19ca+ 1642-0x2033));}sub __getKeyFromFile{(my $ref_parameters=shift (
@_));unless (Common::NXFile::isExists ($$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"})){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x4e\x6f\x74\x45\x78\x69\x73\x74"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"});return ((0x0e0a+ 4885-0x211f));}(my $INFILE=
Common::NXCore::nxopen ($$ref_parameters{"\x6b\x65\x79\x46\x69\x6c\x65"},
$NXBits::O_RDONLY));unless (defined ($INFILE)){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x52\x65\x61\x64"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"});return ((0x1b8f+ 994-0x1f71));}if ((
Common::NXCore::nxread ($INFILE,(\$$ref_parameters{"\x6b\x65\x79"}))==
(0x01ed+ 2847-0x0d0c))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x45\x6d\x70\x74\x79\x46\x69\x6c\x65"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x6b\x65\x79\x46\x69\x6c\x65"});Common::NXCore::nxclose ($INFILE);return (
(0x07e5+ 7824-0x2675));}Logger::debug ((((("\x4b\x65\x79\x20\x27".
$$ref_parameters{"\x6b\x65\x79"}).
"\x27\x20\x72\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x66\x69\x6c\x65\x20\x27").
$$ref_parameters{"\x6b\x65\x79\x46\x69\x6c\x65"})."\x27\x2e"));
Common::NXCore::nxclose ($INFILE);return ((0x2269+ 1008-0x2658));}sub 
__getKeyFromSTDIN{(my $ref_parameters=shift (@_));(my $message=
"\x4e\x58\x3e\x20\x39\x32\x33\x20\x50\x6c\x65\x61\x73\x65\x20\x65\x6e\x74\x65\x72\x20\x74\x68\x65\x20\x73\x73\x68\x2d\x64\x73\x73\x20\x6b\x65\x79\x3a"
);(my $bytes=main::nxwrite (main::nxgetSTDOUT (),$message));unless (($bytes>
(0x0a19+ 2795-0x1504))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6b\x65\x79\x20\x72\x65\x71\x75\x65\x73\x74\x20\x6f\x6e\x20\x53\x54\x44\x4f\x55\x54\x2e"
);return ((0x08e7+ 2148-0x114b));}(($$ref_parameters{"\x6b\x65\x79"},
$$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$$ref_parameters{
"\x75\x75\x69\x64"})=__retrieveKey ());if (($$ref_parameters{"\x6b\x65\x79"}eq 
(""))){Logger::error (
"\x50\x75\x62\x6c\x69\x63\x20\x6b\x65\x79\x20\x6e\x6f\x74\x20\x70\x72\x6f\x76\x69\x64\x65\x64\x2e"
);return ((0x0488+ 182-0x053e));}($$ref_parameters{"\x6b\x65\x79"}.="\x0a");
return ((0x04d3+ 3768-0x138a));}sub prepareKey{(my $ref_parameters=shift (@_));(my $proto
=$$ref_parameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"});if (($proto eq "\x4e\x58"
)){(my $authFile=NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $authDir=
Common::NXFile::dirname ($authFile));Logger::debug (((
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x41\x75\x74\x68\x6f\x72\x69\x7a\x65\x64\x20\x6b\x65\x79\x73\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20\x27"
.$authDir)."\x27\x2e"));if ((not (Common::NXFile::directoryExists ($authDir)))){my (
$error);unless (Common::NXPaths::createAccessibleForNXDirectory ((\$error),
$authDir)){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x44\x69\x72"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$proto,$authDir);return ((0x0054+ 3313-0x0d45));
}}($$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"}=$authFile);Logger::debug
 (((
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x41\x75\x74\x68\x6f\x72\x69\x7a\x65\x64\x20\x6b\x65\x79\x73\x20\x66\x69\x6c\x65\x20\x27"
.$$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"})."\x27\x2e"));}elsif ((
$proto eq "\x53\x53\x48")){($$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"}
=NXPaths::getNodePublicKeys ());if (isKeyInFile ($$ref_parameters{"\x6b\x65\x79"
},$$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"},$proto)){
removeKeyFromFile ($$ref_parameters{"\x6b\x65\x79"},$$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"},$proto);}}else{NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x55\x6e\x6b\x6e\x6f\x77\x6e\x50\x72\x6f\x74\x6f"
,"\x4e\x58\x53\x68\x65\x6c\x6c");return ((0x111a+ 1144-0x1592));}if (
Common::NXFile::isExists ($$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"}))
{if ((Common::NXFile::setPermissionsReadWriteForNX ($$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"})==(-(0x1dd1+ 2123-0x261b)))){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x50\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$proto,$$ref_parameters{
"\x61\x75\x74\x68\x46\x69\x6c\x65"});return ((0x09f7+ 1871-0x1146));}}return (
(0x1b2a+ 2850-0x264b));}sub setKey{(my $ref_parameters=shift (@_));(my $filepath
=$$ref_parameters{"\x61\x75\x74\x68\x46\x69\x6c\x65"});(my $mode=((
$NXBits::O_WRONLY+$NXBits::O_CREAT)+$NXBits::O_APPEND));(my $permissions=
$NXBits::UserReadWrite);(my $OUTFILE=Common::NXCore::nxopen ($filepath,$mode,
$permissions));unless (defined ($OUTFILE)){(my $errorString=
libnxh::NXGetErrorName ());NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x54\x6f\x57\x72\x69\x74\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$filepath);return ((0x07a2+ 3733-0x1637));}(my $keyToSave
=$$ref_parameters{"\x6b\x65\x79"});if (($$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"}eq "\x53\x53\x48")){($keyToSave=
NXNodeExec::addPrefixForSSHKey ($$ref_parameters{"\x6b\x65\x79"}));}if ((
Common::NXCore::nxwrite ($OUTFILE,$keyToSave)==(-(0x0930+ 2104-0x1167)))){
NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x57\x72\x69\x74\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$filepath);Common::NXCore::nxclose ($OUTFILE
);return ((0x01c5+ 1682-0x0857));}Common::NXCore::nxclose ($OUTFILE);if ((
Common::NXFile::setOwnerShipAndPermissionsForNX ($filepath)==(-
(0x18eb+ 2215-0x2191)))){NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x50\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73"
,"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",$$ref_parameters{
"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"},$filepath);return ((0x1250+ 2618-0x1c8a));}
if (($$ref_parameters{"\x75\x75\x69\x64"}ne (""))){NXNodes::setAccessKey (
$$ref_parameters{"\x75\x75\x69\x64"},$$ref_parameters{"\x6b\x65\x79"});}return (
(0x028f+ 7215-0x1ebd));}sub __retrieveKey{(my $selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;(my $signalFd=$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});($$NXBegin::parser
{"\x73\x69\x67\x62\x61\x63\x6b"}{"\x49\x4e\x54"}=sub{Common::NXCore::nxexit ();}
);$selector->add ($signalFd);$selector->add (main::nxgetSTDIN ());(my $key=(""))
;(my $protocol=(""));(my $finish=(0x045b+ 5194-0x18a5));while (($finish==
(0x05cb+ 6732-0x2017))){(my (@ready)=$selector->can_read ((0x14f5+ 5813-0x1822))
);if ((scalar (@ready)==(0x1740+ 755-0x1a33))){Logger::debug (
"\x4e\x6f\x74\x68\x69\x6e\x67\x20\x74\x6f\x20\x72\x65\x61\x64\x2e");($finish=
(0x0349+ 2858-0x0e72));}foreach my $fh (@ready){Logger::debug (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x46\x44\x23".$fh)."\x2e"));if (($fh==
main::nxgetSTDIN ())){my ($read_buf);(my $bytes_read=main::nxread ($fh,(
\$read_buf),(0x170a+ 4546-0x18cc)));Logger::debug (((
"\x52\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x53\x54\x44\x49\x4e\x20\x27".$read_buf
)."\x27\x2e"));if (($read_buf=~ /NX> params=(.*) / )){(my (%hashParameters)=
NXShell::urlParameter2Hash ($1));($key=$hashParameters{"\x6b\x65\x79"});(
$protocol=$hashParameters{"\x70\x72\x6f\x74\x6f\x63\x6f\x6c"});($uuid=
$hashParameters{"\x75\x75\x69\x64"});$selector->remove (main::nxgetSTDIN ());
$selector->remove ($signalFd);($finish=(0x1707+ 1392-0x1c76));}elsif ((
$bytes_read==(0x0519+ 7088-0x20c9))){$selector->remove (main::nxgetSTDIN ());
$selector->remove ($signalFd);($finish=(0x1fdd+ 1186-0x247e));}}}}return ($key,
$protocol,$uuid);}NXMsg::register_response (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x41\x64\x64\x69\x6e\x67\x4b\x65\x79",(0x2199+ 817-0x2430));
NXMsg::register_response ("\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x41\x64\x64\x65\x64\x4f\x6b"
,(0x1871+ 2075-0x1ff1));NXMsg::register_error (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x4e\x6f\x74\x45\x78\x69\x73\x74"
,(0x0dec+ 361-0x0d11));NXMsg::register_error (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x43\x61\x6e\x6e\x6f\x74\x52\x65\x61\x64"
,(0x0b86+ 6576-0x22f2));NXMsg::register_error (
"\x4b\x65\x79\x73\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x4b\x65\x79\x45\x6d\x70\x74\x79\x46\x69\x6c\x65"
,(0x1b27+ 1919-0x2062));return ((0x01a9+ 4876-0x14b4));
