############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXRedis::BEGIN{package NXRedis;no warnings;require NXMsg;do{
"\x4e\x58\x4d\x73\x67"->import};}package NXRedis;no warnings;$selector;
$readRedis;$writeRedis;$daemonRedis;$clientRedis;($retry=(0x05c2+ 2238-0x0e80));
($connected=(0x0057+ 4858-0x1351));($serverInit=(0x0b75+ 5510-0x20fb));(
$multiCommand=(0x04c3+ 5257-0x194c));($resendSuccess=(0x092c+ 489-0x0b15));(
$waitingConnect=(0x1bb8+ 759-0x1eaf));($lockFileHandle=(-(0x0e61+ 2405-0x17c5)))
;($redisServerPid=(-(0x1789+ 248-0x1880)));($waitingForAcquireTimeout=
(0x0914+ 3484-0x15fc));($waitingForReleaseCounter=(0x228d+ 611-0x24f0));(
$waitingForNewDaemonCounter=(0x0e72+ 3127-0x1aa9));($waitingForReleaseSendKill=
(0x15cb+ 3827-0x24a0));($waitingForRedisDaemonReply=(0x1329+ 1266-0x1818));(
$waitingForNonDaemonServerReleaseTimeout=(0x1dac+ 630-0x1fbe));(
$timeoutForNewDaemonWaiting=(0x01d7+ 8083-0x207a));($waitingForNewDaemonTick=0.5
);($failCounter=(0x08ca+ 5528-0x1e62));($finalizeProcessStarted=
(0x1003+ 2318-0x1911));($doNotCloseRedisThreadsWhenFreePerl=
(0x118c+ 2868-0x1cc0));($waitForResponseTimeout=(0x08c3+ 1022-0x0cb7));(
$waitIntervalTime=0.1);($maxWaitTimeout=(0x02b3+ 5338-0x1661));
@waitingCommandList;@responses;@sendCommandList;($descriptorLimit=
(0x1b00+ 5571-0x20c3));($errorDuringLastCommand=(0x1c8d+ 1543-0x2294));sub 
initRedisServer{if (($serverInit==(0x031d+ 2254-0x0beb))){(my $cookie=
NXServerDaemon::getCookie ());setNxDirInNXHomeDirOwner ();if (
main::nxPipeCreateBi ((\$daemonRedis),(\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);return;}(my $returnValue=libnxhs::NXRedisServerCreate ($daemonRedis,$cookie,
NXPaths::getRedisDatabaseDirectory (),NXPaths::getNXErrorFile ()));if ((
$returnValue==(0x1c0b+ 1686-0x22a0))){($serverInit=(0x2082+ 685-0x232e));
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);}else{Logger::error ((
(
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x69\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x65\x72\x72\x6f\x72\x20\x77\x69\x74\x68\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));(my $error=libnxh::NXGetErrorName ());(my $errorstring=
libnxh::NXGetErrorString ());Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20".
$error)."\x3a\x20").$errorstring)."\x2e"));main::nxexit ();}}elsif ((not (
checkRedisFlock ()))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);removeRedisServerLockFileHandle ();}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x74\x68\x69\x73\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);}}sub auth{my ($cookie);if (($serverInit==(0x1c3a+ 1102-0x2088))){($cookie=
NXClientSystemDaemons::getCookieForRedisAuthentication ());}else{($cookie=
NXServerDaemon::getCookie ());}if (($cookie ne (""))){sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x61\x75\x74\x68\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d"
.$cookie)."\x0a"));(my $returnValue=get ());if (($returnValue ne "\x4f\x4b")){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));forceCloseRedisClient ();checkFailCounter ();return (
(0x1db9+ 327-0x1eff));}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x64\x2e"
);($failCounter=(0x05c9+ 7730-0x23fb));return ((0x0b06+ 3596-0x1912));}}else{
forceCloseRedisClient ();checkFailCounter ();Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x69\x6f\x6e\x20\x63\x6f\x6f\x6b\x69\x65\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2c\x20\x63\x61\x6e\x6e\x6f\x74\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((0x0d13+ 2781-0x17ef));}}sub initRedisClient{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x49\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);if ((($readRedis eq (""))or ($writeRedis eq ("")))){if (
libnxhs::NXRedisClientRunning ()){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x72\x65\x61\x74\x65\x64\x2e"
);Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29"
);(my $FD=libnxhs::NXSubsystemGetRedisFd ());Logger::debug2 (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$FD)."\x27\x2e"));if (($FD>=(0x08cb+ 172-0x0977))){($connected=
(0x0c92+ 4842-0x1f7b));($readRedis=$FD);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x69\x6e\x68\x65\x72\x69\x74\x65\x64\x20\x46\x44\x23"
.$FD)."\x2e"));($selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});}else{Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x2e"
);}if (checkIfSubscriptionShouldBeStarted ()){main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}return;}if ((not (
main::nxPipeCreateBi ((\$readRedis),(\$writeRedis))))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x18ff+ 3403-0x264a));}(my $homeDir=NXPaths::getUserNXHomeDir ());
libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$homeDir);Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x28"
.$writeRedis)."\x2c\x20").$writeRedis)."\x29"));(my $rettmp=
libnxhs::NXRedisCreate ($writeRedis,$writeRedis));Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$rettmp)."\x27\x2e"));Common::NXCore::doNotCloseSocketAtFinish ($writeRedis);}(
$selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});if (($serverInit==(0x066b+ 3033-0x1244))){if ((
NXClientSystemDaemons::openConnection ((0x0941+ 2919-0x14a7))!=
(0x0c81+ 5876-0x2374))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x1e22+ 1922-0x25a4));}if (main::nxPipeCreateBi ((\$daemonRedis),(
\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x035a+ 6569-0x1d03));}(my $socketCookie=main::get_unique_id ());(my $tmpDir
=NXPaths::getTmpDir ());(my $socketPath=(($tmpDir.$GLOBAL::DIRECTORY_SLASH).
main::get_unique_id ()));(my $message=(("\x4e\x58\x3e\x20".
$GLOBAL::MSG_REDIS_YIELD)."\x20\x52\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64"));(
$message.=("\x20\x70\x69\x64\x3d".$ $));
 ($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64\x3d".
main::urlencode ($socketPath)));($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65\x3d".$socketCookie));(
$message.=("\x20\x66\x64\x3d".$daemonRedis));($message.="\x20\x0a");if ((
NXClientSystemDaemons::sendMessage ($message)!=(0x1ad9+ 558-0x1d06))){
Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x0a86+ 881-0x0df7));}Server::saveTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65",
"\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x63\x71\x75\x69\x72\x65\x2e"
);(my $response=NXClientSystemDaemons::getDaemonReplyAboutRedis (
$waitingForAcquireTimeout));if (($response ne getMessageStartAcquire ())){if ((
$response eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x74\x69\x6d\x65\x6f\x75\x74\x3a\x20"
.$waitingForAcquireTimeout)."\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));}else{
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20"
.$response)."\x2e"));}NXClientSystemDaemons::closeConnection ();return (
(0x0545+ 2006-0x0d1b));}if ((Common::NXDescriptor::yield ($daemonRedis,
$socketPath,$socketCookie)==(-(0x2326+ 330-0x246f)))){Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x79\x69\x65\x6c\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$daemonRedis).
"\x20\x77\x69\x74\x68\x20\x73\x6f\x63\x6b\x65\x74\x20\x70\x61\x74\x68\x20").
$socketPath)."\x2e"));NXClientSystemDaemons::closeConnection ();main::nxexit (
(0x04f4+ 8121-0x24ac));}($response=(""));($response=
NXClientSystemDaemons::getDaemonReplyAboutRedis ($waitingForRedisDaemonReply));
if (($response eq getMessageAcquireFail ())){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x61\x69\x6c\x65\x64\x2e"
);NXClientSystemDaemons::closeConnection ();main::nxexit ((0x0f0b+ 2503-0x18d1))
;}if (($response ne getMessageAcquireDone ())){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x64\x75\x72\x69\x6e\x67\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x3a\x20"
.$response)."\x2e"));NXClientSystemDaemons::closeConnection ();return (
(0x0247+ 1200-0x06f7));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x58\x52\x65\x64\x69\x73\x41\x63\x71\x75\x69\x72\x65\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x66\x74\x65\x72\x20"
.Server::getTimePassedFromSavedTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65")).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));
Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);
NXClientSystemDaemons::closeConnection ();Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x70\x61\x73\x73\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x74\x68\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);}($connected=(0x221d+ 1007-0x260b));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6f\x6e\x6e\x65\x63\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x66\x64\x3d"
.$clientRedis)."\x0a"));if ((get ()eq "\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64")){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($clientRedis);if ((auth ()==
(0x016c+ 3525-0x0f30))){return (initRedisClient ());}($redisServerPid=
__getRedisServerPid ());if (($serverInit==(0x17ef+ 1641-0x1e57))){
main::nxrequire ("\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");
NXRedisScript::loadAllScriptsToDb ();}if (checkIfSubscriptionShouldBeStarted ())
{main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);}}sub sendToDb{(my $msg=shift (@_));if ((Server::isDaemonProcess ()and (
$serverInit==(0x0b42+ 5236-0x1fb6)))){if ((
NXServerDaemon::checkAndSetServerDaemonFlock ()==(0x0630+ 4167-0x1677))){
Logger::error (
"\x41\x6e\x6f\x74\x68\x65\x72\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x69\x6e\x73\x74\x61\x6e\x63\x65\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxexit ();}main::nxrequire (
"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73");if (
NXSystemDaemons::savePid ("\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 Logger::error
 (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x61\x76\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x70\x69\x64\x2e"
);main::nxexit ();}if ((__checkAndSetRedisServerFlock ()==(0x0d4b+ 6507-0x26b5))
){initRedisServer ();($waitingForReleaseCounter=(0x0fc3+ 4120-0x1fdb));}else{if 
(($waitingForReleaseCounter>$waitingForReleaseSendKill)){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e\x20\x45\x78\x69\x74\x69\x6e\x67\x2e"
);main::nxexit ((0x091c+ 3289-0x15f5));}if (($waitingForReleaseCounter==
$waitingForReleaseSendKill)){(my $redisServerPid=__getRedisServerPid ());
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x6b\x69\x6c\x6c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$redisServerPid).
"\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
));__killOtherRedisServer ($redisServerPid);}Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4f\x74\x68\x65\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x63\x75\x72\x72\x65\x6e\x74\x6c\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxsleep (0.5);(++$waitingForReleaseCounter);return (sendToDb ($msg));}}
main::nxrequire ("\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73")
;if ((((((($connected==(0x0328+ 1526-0x091e))and (
NXSystemDaemons::isShutdownFlag ()==(0x032c+ 7254-0x1f82)))and ($redisServerPid
!=(-(0x0140+ 3456-0x0ebf))))and ($serverInit==(0x20f1+ 612-0x2355)))and (
NXServerDaemon::checkDaemonFlock ()==(0x015c+ 838-0x04a1)))and (
$finalizeProcessStarted==(0x1171+ 4467-0x22e4)))){(++$waitingForNewDaemonCounter
);main::nxsleep ($waitingForNewDaemonTick);if (($waitingForNewDaemonCounter>=
$timeoutForNewDaemonWaiting)){($redisServerPid=(-(0x01cb+ 7887-0x2099)));(my $logTimeout
=($waitingForNewDaemonCounter *$waitingForNewDaemonTick));(
$waitingForNewDaemonCounter=(0x1194+ 671-0x1433));Logger::error (((
"\x53\x65\x72\x76\x65\x72\x20\x6c\x6f\x73\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x6e\x64\x20\x74\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x6e\x65\x77\x20\x6f\x6e\x65\x20"
.$logTimeout).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));closeDb
 ((0x0459+ 4205-0x14c5));main::nxexit ((0x1092+ 2106-0x18cb));}else{return (
sendToDb ($msg));}}($waitingForNewDaemonCounter=(0x039f+ 8960-0x269f));if ((((
$connected==(0x011a+ 714-0x03e4))and ($serverInit==(0x0416+ 231-0x04fd)))and (
not (Server::isDaemonProcess ())))){if ((NXSystemDaemons::isShutdownFlag ()==
(0x0bea+ 5627-0x21e4))){if ((__checkAndSetRedisServerFlock ()==
(0x0e36+ 692-0x10e9))){initRedisServer ();($waitingForReleaseCounter=
(0x05b1+ 7242-0x21fb));}else{removeRedisServerLockFileHandle ();if ((
$waitingForReleaseCounter==$waitingForNonDaemonServerReleaseTimeout)){
Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x12c7+ 4737-0x2548));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}elsif ((NXServerDaemon::checkDaemonFlock ()==
(0x02d2+ 2790-0x0db7))){if ((($GLOBAL::isNXServerLoginProcess==
(0x10c7+ 5338-0x25a1))or (($GLOBAL::isNXServerLoginProcess==(0x0317+ 873-0x067f)
)and ($finalizeProcessStarted==(0x15b9+ 2035-0x1dab))))){if ((
__checkAndSetRedisServerFlock ()==(0x0951+ 7472-0x2680))){initRedisServer ();(
$waitingForReleaseCounter=(0x04b1+ 5219-0x1914));}else{
removeRedisServerLockFileHandle ();if (($waitingForReleaseCounter==
$waitingForNonDaemonServerReleaseTimeout)){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x1b9a+ 829-0x1ed7));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x73\x20\x6c\x6f\x67\x69\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);checkFailCounter ();return ((0x06b3+ 2897-0x1204));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}}if (($connected==(0x1186+ 1588-0x17ba))){initRedisClient ();}if (($connected
==(0x0ac8+ 5768-0x2150))){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x0079+ 2846-0x0b97));}if ((__checkCommandLine ((\$msg))==
(0x0691+ 5173-0x1ac5))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$msg)."\x27\x20\x61\x62\x6f\x72\x74\x65\x64\x2e"));return (
(0x0166+ 6992-0x1cb6));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x27".$msg)
."\x27\x2e"));if ((main::nxwrite ($readRedis,$msg)==(-(0x095a+ 1811-0x106c)))){
if (($retry==(0x0903+ 5877-0x1ff8))){closeDb ();($retry=(0x0911+ 3192-0x1588));
sendToDb ($msg);}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x096d+ 3852-0x1879));}}($retry=(0x1068+ 2872-0x1ba0));push (
@sendCommandList,$msg);return ((0x0a40+ 6762-0x24a9));}sub sendToDbAndSave{(my $msg
=shift (@_));if ((sendToDb ($msg)==(0x09b2+ 464-0x0b81))){saveDb ();}}sub 
sendToDbAndGetReply{(my $request=shift (@_));if ((sendToDb ($request)==
(0x0bb3+ 4442-0x1d0c))){return (split ( / / ,get (),(0x0a64+ 6771-0x24d7)));}
return (undef);}sub readFromDb{my ($read_buf);(my $bytes_read=main::nxread (
$readRedis,(\$read_buf),32768));if ((($bytes_read eq (0x0904+ 3606-0x171a))or (
$bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x125f+ 1334-0x1795));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x64\x61\x74\x61\x20\x6f\x6e\x20\x52\x65\x64\x69\x73\x20\x73\x6f\x63\x6b\x65\x74\x3a\x20\x27"
.$response)."\x27\x2e"));parseRedisOutput ($response);}}sub get{(my $callbackTimeout
=(shift (@_)||(0x09f4+ 1230-0x0ec2)));(my $ref_timeoutCallback=shift (@_));if ((
$sendCommandList[-(0x0b81+ 6503-0x24e7)]eq (""))){return ((""));}push (
@waitingCommandList,$sendCommandList[-(0x08c4+ 2518-0x1299)]);(my $tmpLastCommand
=__getCommandNameFromLine ($sendCommandList[-(0x200f+ 1656-0x2686)]));my (
$returnValue);if ((waitForReponse ($callbackTimeout,$ref_timeoutCallback)==
(0x150f+ 3493-0x22b3))){($returnValue=pop (@responses));($failCounter=
(0x11af+ 4992-0x252f));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{
if ((checkFailure ()==(0x024f+ 2668-0x0cbb))){if ((waitForReponse (
$callbackTimeout,$ref_timeoutCallback)==(0x14db+ 4650-0x2704))){($returnValue=
pop (@responses));($failCounter=(0x06b8+ 7302-0x233e));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{(
@waitingCommandList=());(@responses=());shift (@sendCommandList);Logger::error (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x61\x66\x74\x65\x72\x20\x72\x65\x73\x65\x6e\x64\x69\x6e\x67\x2e"));}}else{
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x52\x65\x73\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x20\x66\x61\x69\x6c\x65\x64\x2e"
));}}return ($returnValue);}sub getWithCallbackOnTimeout{(my $callbackTimeout=
shift (@_));(my $ref_timeoutCallback=shift (@_));if (($maxWaitTimeout<
$callbackTimeout)){return (get ());}(my $defaultTimeout=$waitForResponseTimeout)
;($waitForResponseTimeout=$maxWaitTimeout);(my $result=get ($callbackTimeout,
$ref_timeoutCallback));($waitForResponseTimeout=$defaultTimeout);return ($result
);}sub waitForReponse{(my $callbackTimeout=(shift (@_)||(0x1194+ 3052-0x1d80)));
(my $ref_timeoutCallback=shift (@_));(my $waitTime=(0x0794+ 3280-0x1464));(my $waitForResponseTimeout
=($waitForResponseTimeout *(0x0baf+ 960-0x0b87)));(my $maxSelectTimeout=
$waitForResponseTimeout);if ($callbackTimeout){($maxSelectTimeout=
$callbackTimeout);}if (((__getCommandNameFromLine ($waitingCommandList[
(0x16a4+ 980-0x1a78)])eq "\x61\x75\x74\x68")or (__getCommandNameFromLine (
$waitingCommandList[(0x0479+ 2638-0x0ec7)])eq "\x65\x76\x61\x6c\x73\x68\x61"))){
($waitForResponseTimeout=(($NXRedis::waitForResponseTimeout *
(0x090c+ 2624-0x0f64))*(0x00bc+ 5314-0x1578)));($maxSelectTimeout=
$waitForResponseTimeout);}($selectTimeout=$maxSelectTimeout);(my $startTime=
Common::NXTime::getMillisecondsSinceEpoch ());(my $lastTimeoutCallbackCall=
(0x103b+ 2839-0x1b52));while (((@waitingCommandList and ($waitTime<
$waitForResponseTimeout))and (($connected==(0x1bb7+  92-0x1c12))||(
__getCommandNameFromLine ($waitingCommandList[(0x1281+ 3341-0x1f8e)])eq 
"\x63\x6f\x6e\x6e\x65\x63\x74")))){(my (@ready)=$selector->can_read (
$selectTimeout));foreach my $fh (@ready){if (($fh eq $readRedis)){if (
@waitingCommandList){readFromDb ();}}}if (@waitingCommandList){if ((
$resendSuccess==(0x0cf3+ 4367-0x1e01))){($waitTime=(0x194d+ 258-0x1a4f));(
$selectTimeout=$maxSelectTimeout);($startTime=
Common::NXTime::getMillisecondsSinceEpoch ());($resendSuccess=
(0x1383+ 3860-0x2297));}else{($waitTime=(
Common::NXTime::getMillisecondsSinceEpoch ()-$startTime));if ($callbackTimeout){
if ((($waitTime+$selectTimeout)>$waitForResponseTimeout)){($selectTimeout=(
$waitForResponseTimeout-$waitTime));}}else{($selectTimeout=($maxSelectTimeout-
$waitTime));}}if ($callbackTimeout){if ((($lastTimeoutCallbackCall+
$callbackTimeout)<Common::NXTime::getSecondsSinceEpoch ())){&{
$ref_timeoutCallback;}();($lastTimeoutCallbackCall=
Common::NXTime::getSecondsSinceEpoch ());}}}}if (($connected!=
(0x2084+ 1395-0x25f6))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x69\x65\x6e\x74\x20\x77\x61\x73\x20\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2c\x20\x71\x75\x69\x74\x20\x77\x61\x69\x74\x69\x6e\x67\x2e"
);return ((0x08b1+ 4790-0x1b67));}if (@waitingCommandList){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x03a0+ 6665-0x1da9)])).((
"\x20\x77\x68\x69\x63\x68\x20\x69\x73\x20".$NXRedis::waitForResponseTimeout).
"\x20\x68\x61\x73\x20\x62\x65\x65\x6e\x20\x72\x65\x61\x63\x68\x65\x64\x2e")));
checkFailCounterAndCloseIfNeeded ();return ((0x160c+ 834-0x194e));}return (
(0x0e99+ 1220-0x135c));}sub parseRedisOutput{(my $output=shift (@_));($output.=
"\x20");(my (@lines)=split ( /\n/ ,$output,(0x0059+ 6405-0x195e)));while (@lines
){(my $line=shift (@lines));if (($line=~ /event=disconnected,error=0/ )){(
$connected=(0x161b+ 173-0x16c8));next;}(my $response=shift (@lines));unless (
@sendCommandList){return;}my ($firstWaitingCommand);if (@waitingCommandList){(
$firstWaitingCommand=__getCommandNameFromLine ($waitingCommandList[
(0x1086+ 4244-0x211a)]));}if ((handleCommandSuccesful ($line)==
(0x10ca+ 4226-0x214b))){return;}if (($line=~ /command=connect,error=0/ )){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e");
($connected=(0x06f0+  89-0x0748));shift (@waitingCommandList);push (@responses,
"\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");next;}elsif (($line=~ /command=connect,error=/ )
){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x2e"
);shift (@waitingCommandList);push (@responses,
"\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");($connected=
(0x08fd+ 3797-0x17d2));next;}elsif ((($line=~ /command=(.*),error=0/ )and (
$response ne ("")))){(my $command=$1);if (($command eq $firstWaitingCommand)){(my $fullResponse
=$response);if (($command eq "\x63\x6c\x69\x65\x6e\x74")){while ((@lines and (
$lines[(0x02e7+ 5968-0x1a37)]=~ /^id=/ ))){($fullResponse.=("\x0a".shift (@lines
)));}}push (@responses,$fullResponse);shift (@waitingCommandList);next;}else{
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=(.*),error=0,size=0/ )
and ($response eq ("")))){(my $command=$1);if (($command eq $firstWaitingCommand
)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6e\x6f\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x167b+ 2586-0x2095)])).
"\x20\x73\x61\x76\x65\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"))
;push (@responses,(""));shift (@waitingCommandList);next;}else{Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=bgsave,error=1/ )and
 ($response=~ /ERR Background save already in progress/ ))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x61\x76\x69\x6e\x67\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x69\x6e\x20\x70\x72\x6f\x67\x72\x65\x73\x73\x2c\x20\x73\x6b\x69\x70\x69\x6e\x67\x2e"
);push (@responses,(""));shift (@waitingCommandList);shift (@sendCommandList);
next;}elsif (($line=~ /command=(.*),error=(.*)/ )){(my $error=$2);(
$errorDuringLastCommand=(0x103f+ 1239-0x1515));if (($error ne (""))){if ((
__handleRedisErrorIfPossible ($response)==(0x03b0+ 7257-0x2008))){return;}
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x0a5c+ 1210-0x0f16)])).((((
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x3a\x20").$response).
"\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
)));}else{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x049c+ 522-0x06a6)])).
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
));}($connected=(0x00a2+ 346-0x01fc));}elsif (($line eq (""))){next;}elsif ((
$response=~ /event=disconnected,error=0/ )){($connected=(0x0219+ 975-0x05e8));
next;}}}sub getRedisDescriptor{return ($readRedis);}sub saveDb{Logger::debug (
"\x53\x61\x76\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);if (($serverInit==(0x0339+ 1701-0x09dd))){sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}else{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x62\x67\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}(my $saveResponse=get ());}sub closeDb{(my $finalizeProcess=(shift (@_)||
(0x1201+ 772-0x1505)));if (($finalizeProcess==(0x0530+  24-0x0547))){(
$finalizeProcessStarted=(0x07bf+ 3171-0x1421));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x64\x62\x2e"
);while ((scalar (@sendCommandList)>(0x1627+ 2034-0x1e19))){(my $command=
__getCommandNameFromLine ($sendCommandList[(0x12e1+ 4254-0x237f)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command).
"\x27\x20\x62\x65\x66\x6f\x72\x65\x20\x63\x6c\x6f\x73\x69\x6e\x67\x2e"));get ();
}if (($doNotCloseRedisThreadsWhenFreePerl==(0x1e80+ 1161-0x2308))){Logger::debug
 (
"\x4c\x65\x61\x76\x69\x6e\x67\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x6e\x64\x20\x72\x65\x64\x69\x73\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x74\x68\x72\x65\x61\x64\x2e"
);return;}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::closeSubscription ();if (($connected==(0x098f+ 5690-0x1fc8)
)){Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29"
);(my $returnValue=libnxhs::NXRedisClientDestroy ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$returnValue)."\x27\x2e"));Common::NXSelector::removeFromGlobalSelector (
$readRedis);($readRedis=(""));($connected=(0x1764+ 2742-0x221a));}if ((
$serverInit==(0x2275+ 1144-0x26ec))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);if ((libnxhs::NXRedisServerDestroy ()==(0x1591+ 3929-0x24e9))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);removeRedisServerLockFileHandle ();(my $redisLock=getRedisLockFile ());if ((
not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $redisPidFile=getRedisPidFile ());if ((not (
unlink ($redisPidFile)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $dbFile=NXPaths::getRedisDatabaseFile ());if 
(Common::NXFile::fileExists ($dbFile)){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($dbFile,(\$errorMsg))==(-
(0x0189+ 7183-0x1d97)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x27"
.$dbFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x63\x6c\x6f\x73\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}($serverInit=(0x0658+ 926-0x09f6));}}sub isRedisDatabaseInit{if (
Server::isDaemonProcess ()){if (($serverInit==(0x099d+ 5753-0x2015))){return (
(0x0813+ 3863-0x1729));}else{return ((0x1b81+ 1625-0x21da));}}if (
isRedisLockFileExist ()){return ((0x1ca2+ 734-0x1f7f));}else{return (
(0x17a8+ 1877-0x1efd));}}sub getRedisLockFile{(my $redisLockFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH)."\x72\x65\x64\x69\x73"))
;return ($redisLockFile);}sub getRedisPidFile{(my $redisPidFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH).
"\x72\x65\x64\x69\x73\x2e\x70\x69\x64"));return ($redisPidFile);}sub 
isRedisLockFileExist{(my $file=getRedisLockFile ());if (
Common::NXFile::fileExists ($file)){return ((0x0aa9+ 1793-0x11a9));}else{return 
((0x246c+ 531-0x267f));}}sub isNotRedisDatabaseInit{return ((!
isRedisDatabaseInit ()));}sub daemonAcquire{(my $message=shift (@_));(my $socket
=shift (@_));(my (%parameters)=());(my $redisDescriptor=(-(0x0710+ 5560-0x1cc7))
);if (($serverInit==(0x2101+ 1391-0x2670))){return ((0x1a7d+ 2652-0x24d8));}if (
($message=~ /Redis yield/ )){($message=~ s/Redis yield // );(my (@args)=split ( / / ,
$message,(0x1ad3+ 2853-0x25f8)));foreach my $pair (@args){(my ($key,$value)=
split ( /=/ ,$pair,(0x0b2d+ 4832-0x1e0a)));($parameters{$key}=$value);}(my $socketPath
=main::urldecode ($parameters{
"\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64"}));(my $msg
=getMessageStartAcquire ());if ((main::nxwrite ($socket,$msg)==(-
(0x1be1+ 515-0x1de3)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e"
));return ((0x0f43+ 2026-0x172c));}($redisDescriptor=
Common::NXDescriptor::acquire ($parameters{"\x70\x69\x64"},$parameters{
"\x66\x64"},$socketPath,$parameters{
"\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65"}));if ((($redisDescriptor<
(0x091b+ 231-0x0a02))or ($redisDescriptor>$descriptorLimit))){Logger::warning ((
(((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"})."\x20\x61\x6e\x64\x20").$socketPath)."\x2e"));(
$msg=getMessageAcquireFail ());if ((main::nxwrite ($socket,$msg)==(-
(0x1619+ 1716-0x1ccc)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x66\x61\x69\x6c\x2e"
));}return ((0x11cc+ 149-0x1260));}Common::NXCore::doNotCloseSocketAtFinish (
$redisDescriptor);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x63\x65\x69\x76\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$redisDescriptor)."\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x2e"));(my $return
=libnxhs::NXRedisServerConnection ($redisDescriptor));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x28"
.$redisDescriptor)."\x29\x20").$return)."\x2e"));($msg=getMessageAcquireDone ())
;if ((main::nxwrite ($socket,$msg)==(-(0x0c1d+ 1173-0x10b1)))){Logger::warning (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x6f\x6e\x65\x2e"
));}return ((0x1bdf+ 1297-0x20f0));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x68\x61\x6e\x64\x6c\x65\x20\x72\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64\x20\x72\x65\x71\x75\x65\x73\x74\x3a\x20"
.$message)."\x2e"));return ((0x0069+ 3065-0x0c61));}}sub 
isDbRunningInCurrentProcess{return ($serverInit);}sub __lockFile{(my $file=
getRedisLockFile ());my ($errormsg);(my $SERVER_FH=main::nxopen ($file,(
$NXBits::O_WRONLY+$NXBits::O_CREAT),(($NXBits::UserReadWrite+$NXBits::GroupRead)
+$NXBits::OthersRead)));if ((not (defined ($SERVER_FH)))){(my $serverDir=
Common::NXFile::dirname ($file));if ((Common::NXFile::directoryExists (
$serverDir)==(0x0b88+ 3980-0x1b14))){my ($errorMessage);if (
Common::NXPaths::makePath ((\$errorMessage),$serverDir)){if ((
Common::NXFile::setOwnershipForUserNX ($serverDir,(\$errorMessage))==(-
(0x1099+ 2752-0x1b58)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}if ((Common::NXFile::setPermissionsFullForNXDirectory ($serverDir,(
\$errorMessage))==(-(0x0186+ 6165-0x199a)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}($SERVER_FH=main::nxopen ($file,($NXBits::O_WRONLY+$NXBits::O_CREAT),(
($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));}else{
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}}if ((not (defined ($SERVER_FH)))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));return ((-
(0x0f5b+ 2269-0x1837)));}}unless (main::nxflock ($SERVER_FH,$NXBits::LOCK_EX)){
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20"
.$file)."\x2e"));return ((-(0x1688+ 598-0x18dd)));}
Common::NXFile::setOwnershipForUserNX ($file,(\$errormsg));if (($errormsg ne 
(""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errormsg)."\x2e"));}libnxh::NXDescriptorInheritable ($SERVER_FH,
(0x0426+ 592-0x0676));main::closeSocketAtFinish ($SERVER_FH);return ($SERVER_FH)
;}sub __checkAndSetRedisServerFlock{if (($serverInit==(0x0470+  72-0x04b7))){
return ((0x0011+ 3658-0x0e5b));}if ((not (checkRedisFlock ()))){return (
(0x1975+ 1339-0x1eb0));}else{unless ((main::effectiveUserIsAdministrator ()or (
Common::NXCore::getEffectiveUsername ()eq "\x6e\x78"))){if ((
NXSystemDaemons::isShutdownFlag ()==(0x1a70+ 1406-0x1fed))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x69\x6e\x75\x65\x2c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x20\x61\x6e\x64\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6f\x70\x65\x72\x61\x74\x69\x6f\x6e\x20\x72\x65\x71\x75\x69\x72\x65\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,"\x4e\x58\x52\x65\x64\x69\x73");main::nxexit ((0x0239+ 5629-0x1836));}}(my $file
=getRedisLockFile ());unlink ($file);(my $fh=__lockFile ());if (($fh==(-
(0x0a02+ 6684-0x241d)))){return ((0x06ef+ 4370-0x1801));}
setRedisServerLockFileHandle ($fh);saveRedisPid ();return ((0x1a36+  83-0x1a88))
;}}sub checkRedisFlock{if (($serverInit==(0x02f4+ 3720-0x117b))){return (
(0x07b6+ 3274-0x1480));}(my $file=getRedisLockFile ());Logger::debug (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x6c\x6f\x63\x6b\x3a\x20"
.$file)."\x2e"));if ((Common::NXFile::fileExists ($file)==(0x0fb2+ 3411-0x1d05))
){Logger::debug ((("\x46\x69\x6c\x65\x20".$file).
"\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));return (
(0x191a+ 1437-0x1eb6));}(my $SERVER_FH=main::nxopen ($file,$NXBits::O_RDONLY,
(0x066a+ 2352-0x0f9a)));if ((not (defined ($SERVER_FH)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));return ((0x0c51+ 396-0x0ddd));}if ((not (Common::NXCore::nxTryLock (
$SERVER_FH,$NXBits::LOCK_EX)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));main::nxclose ($SERVER_FH);if ((not (Server::isDaemonProcess ()))){
checkFailCounter ();}return ((0x00dc+ 8049-0x204d));}main::nxclose ($SERVER_FH);
return ((0x1116+ 2508-0x1ae1));}sub removeRedisServerLockFileHandle{if ((
$lockFileHandle!=(-(0x14eb+ 1804-0x1bf6)))){main::nxclose ($lockFileHandle);(
$lockFileHandle=(-(0x0a9a+ 1158-0x0f1f)));}}sub setRedisServerLockFileHandle{(
$lockFileHandle=shift (@_));}sub setNxDirInNXHomeDirOwner{(my $path=
NXPaths::getUserNXHomeDir ());my ($errorMsg);if (($path eq (""))){return (
(0x04d9+ 2409-0x0e42));}if ((Common::NXFile::directoryExists ($path)==
(0x1cd8+ 991-0x20b7))){if ((not (Common::NXPaths::makePath ((\$errorMsg),$path))
)){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$path)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMsg)."\x2e"));
return ((0x02d5+ 7402-0x1fbf));}}Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$path);($path.=(
$GLOBAL::DIRECTORY_SLASH."\x2e\x6e\x78"));if ((Common::NXFile::directoryExists (
$path)==(0x1512+ 2308-0x1e16))){Common::NXPaths::createAccessibleForNXDirectory 
((\$errorMsg),$path);}else{Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));}}sub getMessageStartAcquire{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x73\x74\x61\x72\x74\x65\x64\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x2e"
);return ($msg);}sub getMessageAcquireDone{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x64\x64\x65\x64\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub getMessageAcquireFail{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x63\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x61\x64\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub __killOtherRedisServer{(my $serverPid=shift (@_));if (
NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigterm (
$serverPid)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}(my $result=Common::NXProcess::waitProcess ($serverPid,
(0x1dab+ 123-0x1e17)));if (NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigkill (
$serverPid)){if ((not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4b\x69\x6c\x6c\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}}}}sub __getRedisServerPid{(my $redisLockFile=
getRedisPidFile ());(my $pid=(-(0x0558+ 6602-0x1f21)));my ($FH);($FH=
main::nxopen ($redisLockFile,$NXBits::O_RDONLY,(0x05e3+ 2346-0x0f0d)));if ((not 
(defined ($FH)))){(my $errorstring=libnxh::NXGetErrorString ());Logger::error ((
(((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x3a\x20"
.$redisLockFile)."\x3a\x20").$errorstring)."\x2e"));return ((""));}else{(my $r_b
=main::nxread ($FH,(\$pid),(0x0fe5+  34-0x0e07)));main::nxclose ($FH);if (($r_b
==(0x04fa+ 4890-0x1814))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x70\x69\x64\x20\x69\x6e\x3a\x20"
.$redisLockFile)."\x2e"));}}return ($pid);}sub __getCommandNameFromLine{(my $cmdLine
=shift (@_));(my $commandName=(""));(($commandName)=($cmdLine=~ /command=(.*),service/ )
);if (($commandName eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6e\x61\x6d\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$cmdLine)."\x27\x2e"));}return ($commandName);}sub __checkCommandLine{(my $ref_msg
=shift (@_));(my $msg=$$ref_msg);if ((($msg=~ /key=\n/ )or ($msg=~ /key=,/ ))){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6b\x65\x79\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));
return ((0x1586+  70-0x15cb));}if ((($msg=~ / / )and (not (($msg=~ /command=script,service=db,/ )
)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x61\x69\x6e\x20\x73\x70\x61\x63\x65\x73\x2e"
));return ((0x134a+ 320-0x1489));}if (($msg=~ /^(.*),field=(.*),value=,/ )){
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=,/,/ );return (__checkCommandLine ($ref_msg));}if 
(($msg=~ /^(.*),field=(.*),value=\n/ )){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=\n/\n/ );return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /=,/ )or ($msg=~ /=\n/ ))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x65\x6d\x70\x74\x79\x20\x66\x69\x65\x6c\x64\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg)."\x27\x2e"));return ((0x04b3+ 3615-0x12d1));}if ((not (($msg=~ /\n$/ ))))
{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x69\x73\x73\x69\x6e\x67\x20\x6e\x65\x77\x20\x6c\x69\x6e\x65\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x61\x74\x20\x74\x68\x65\x20\x65\x6e\x64\x20\x6f\x66\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$msg)."\x27\x2e"));($$ref_msg.="\x0a");return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /command=(hmset|hset|set),service=db/ )and ((not (($msg=~ /field=(.*)/ )
))and (not (($msg=~ /value=(.*)/ )))))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6e\x6f\x74\x68\x69\x6e\x67\x2e"
));return ((0x0ccf+ 1276-0x11ca));}if (((length ($msg)>16383)and (not (($msg=~ /command=evalsha,service=db,/ )
)))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x69\x73\x20\x6c\x6f\x6e\x67\x65\x72\x20\x74\x68\x61\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x6d\x61\x78\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x73\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x3a\x20\x31\x36\x33\x38\x33\x2e"
);return ((0x0531+ 993-0x0911));}return ((0x0fc6+ 1552-0x15d6));}sub 
resendWaitingCommands{(my $resend=(0x1110+ 1231-0x15df));(my (@newCommandList)=
());unless (@sendCommandList){return ((0x0f91+ 679-0x1238));}(my (
@tmpCommandList)=@sendCommandList);(@waitingCommandList=());(@sendCommandList=()
);foreach my $command (@tmpCommandList){if (($command=~ /command=connect/ )){
next;}if (($command=~ /command=auth/ )){next;}if ((sendToDb ($command)==
(0x15d2+ 371-0x1745))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x65\x6e\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$command)."\x2e"));last;}else{push (@newCommandList,$command);}}if (
@newCommandList){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x73\x65\x6e\x64\x20"
.join ($",@newCommandList))."\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x2e"));(
$resendSuccess=(0x1925+ 2322-0x2236));(@waitingCommandList=@newCommandList);(
@sendCommandList=@newCommandList);return ((0x1c42+ 2090-0x246b));}return (
(0x0791+ 431-0x0940));}sub checkFailure{if (checkRedisFlock ()){($connected=
(0x093b+ 3161-0x1594));(my $redisLockFile=getRedisLockFile ());if ((
Common::NXFile::fileExists ($redisLockFile)==(0x05a9+ 5666-0x1bca))){unlink (
$redisLockFile);}}if ((($connected==(0x0669+ 6404-0x1f6d))or (
__checkIfActualRedisServerPid ()==(0x0c5d+ 469-0x0e32)))){($connected=
(0x0a9d+ 887-0x0e14));$selector->remove ($readRedis);$selector->remove (
$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});if ((resendWaitingCommands ()==
(0x0226+ 3083-0x0e30))){return ((0x0e21+ 5809-0x24d2));}return (
(0x0b27+ 2956-0x16b2));}return ((0x0344+ 9159-0x270b));}sub 
__checkIfActualRedisServerPid{my ($actualRedisServerPid);if (($redisServerPid==(
-(0x10f3+ 2456-0x1a8a)))){return ((0x0b06+ 5358-0x1ff4));}if ((
Common::NXFile::fileExists (getRedisLockFile ())==(0x0062+ 1032-0x0469))){(
$actualRedisServerPid=__getRedisServerPid ());}else{return (
(0x16e2+ 2841-0x21fb));}if (($actualRedisServerPid==$redisServerPid)){return (
(0x1008+ 2452-0x199b));}return ((0x111b+ 2466-0x1abd));}sub 
prepareMultipleCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x75\x6c\x74\x69\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommandsAndSave{sendToDbAndSave (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub isConnected{return ($connected);}sub setDisconnected{($connected=
(0x10f8+ 4125-0x2115));}sub __handleRedisErrorIfPossible{(my $response=shift (@_
));if (($response=~ /LOADING Redis is loading the dataset in memory/ )){
resendWaitingCommands ();return ((0x0c3c+ 5130-0x2045));}elsif (($response=~ /ERR unknown command/ )
){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x75\x6e\x6b\x6e\x6f\x77\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x054a+ 2920-0x10b2)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67"));shift (@waitingCommandList);shift (
@sendCommandList);resendWaitingCommands ();return ((0x12d1+ 4194-0x2332));}elsif
 (($response=~ /Error compiling script/ )){main::nxexit ((0x014d+   1-0x014e));}
elsif (($response=~ /Error running script/ )){main::nxexit ((0x09f4+ 207-0x0ac3)
);}elsif (($response=~ /WRONGTYPE/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x74\x79\x70\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x08b6+ 3693-0x1723)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x1903+ 3004-0x24be))
;}elsif (($response=~ /ERR wrong number of arguments/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x6e\x75\x6d\x62\x65\x72\x20\x6f\x66\x20\x61\x72\x67\x75\x65\x6d\x6e\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x0db1+ 201-0x0e7a)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x009b+ 944-0x044a));
}elsif (($response=~ /NOSCRIPT No matching script/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x73\x63\x72\x69\x70\x74\x20\x27"
.$waitingCommandList[(0x0129+ 7496-0x1e71)]).
"\x27\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
));shift (@waitingCommandList);shift (@sendCommandList);
NXRedisScript::loadAllScriptsToDb ();return ((0x041c+ 231-0x0502));}return (
(0x1785+ 241-0x1876));}sub saveRedisPid{(my $pidFile=getRedisPidFile ());(my $PID_FH
=main::nxopen ($pidFile,(($NXBits::O_WRONLY+$NXBits::O_CREAT)+$NXBits::O_TRUNC),
(($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));if (defined 
($PID_FH)){main::nxwrite ($PID_FH,$ $);
 main::nxclose ($PID_FH);if (
main::effectiveUserIsAdministrator ()){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($pidFile,(\$errorMsg))==(-
(0x1d9d+ 1762-0x247e)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20\x27"
.$pidFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{(my $error=
libnxh::NXGetErrorName ());Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x73\x61\x76\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x70\x69\x64\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x2e"));}}sub checkIfLastOperationWentOk{($errorDuringLastCommand=
(0x1762+ 2177-0x1fe3));(my $result=get ());if ((($result ne (""))and (
$errorDuringLastCommand==(0x0d9b+ 1176-0x1233)))){return ((0x021f+ 8605-0x23bb))
;}return ((0x0c0b+ 5919-0x232a));}sub checkIfSubscriptionShouldBeStarted{if ((
$serverInit==(0x10da+ 4664-0x2312))){return ((0x0a8b+ 3357-0x17a7));}elsif (
Server::isDaemonProcess ()){return ((0x174d+ 2761-0x2215));}else{return (
(0x0431+ 7744-0x2271));}}sub setServerType{(my $type=shift (@_));(my $name=(""))
;sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if ((($oldName eq 
(""))or ($oldName eq "\x6e\x6f\x74\x20\x73\x65\x74"))){($name=$type);}else{(
$name=(($oldName."\x20").$type));}($name=main::urlencode ($name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}sub unsetServerType{(my $type=shift (@_));(my $name=(""));
sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if (($oldName=~ /$type/ )
){($name=$oldName);($name=~ s/ \b$type\b// );($name=~ s/\b$type\b *// );if ((
$name eq (""))){($name="\x6e\x6f\x74\x20\x73\x65\x74");}($name=main::urlencode (
$name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}}sub handleCommandSuccesful{(my $command=shift (@_));if ((
$command eq (""))){return ((0x023a+ 3052-0x0e26));}if (($command=~ /command=(.*),error=0/ )
){if (($command=~ /command=multi/ )){($multiCommand=(0x00e7+ 7105-0x1ca7));
return ((0x01c7+ 994-0x05a9));}if ((($command=~ /command=exec/ )and (
$multiCommand>(0x1030+ 5612-0x261c)))){splice (@sendCommandList,
(0x218a+ 943-0x2539),($multiCommand+(0x1427+ 4144-0x2456)));($multiCommand=
(0x0f3c+ 2506-0x1906));return ((0x200d+ 429-0x21ba));}if (($multiCommand>
(0x0b37+ 6391-0x242e))){(++$multiCommand);return ((0x1975+ 1908-0x20e9));}(my $firstSendCommand
=__getCommandNameFromLine ($sendCommandList[(0x0c6f+ 5919-0x238e)]));if ((
$command=~ /command=(.*),error/ )){(my $receivedCommand=$1);if ((
$receivedCommand eq $firstSendCommand)){shift (@sendCommandList);return (
(0x0695+ 2482-0x1047));}else{Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x55\x6e\x65\x78\x70\x65\x63\x74\x65\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x27"
.$command)."\x27\x2e\x20\x57\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x27").
$firstSendCommand)."\x27\x2e"));(my $secondSendCommand=__getCommandNameFromLine 
($sendCommandList[(0x0e22+ 1639-0x1488)]));if (($receivedCommand eq 
$secondSendCommand)){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$firstSendCommand).
"\x27\x20\x69\x73\x20\x6d\x69\x73\x73\x69\x6e\x67\x2e\x20\x50\x72\x6f\x63\x65\x65\x64\x20\x77\x69\x74\x68\x20\x73\x65\x63\x6f\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));shift (@sendCommandList);shift (@sendCommandList);return (
(0x192a+ 2477-0x22d7));}return ((0x0041+ 5378-0x1542));}}}elsif ((($command=~ /command=(.*),error=(\d+)/ )
or ($connected==(0x04cb+ 7016-0x2033)))){if ((__handleRedisErrorIfPossible (
$response)==(0x0e0f+ 912-0x119e))){return ((0x1012+ 848-0x1361));}return (
(0x0472+ 6579-0x1e25));}}sub commandMonitor{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x6d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x6f\x6e\x69\x74\x6f\x72\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((0x15ab+ 2823-0x20b1)){(my (@ready)=$selector->
can_read ((0x189f+ 1151-0x1166)));foreach my $fh (@ready){if (($fh eq $readRedis
)){my ($read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));
if ((($bytes_read eq (0x1448+ 1439-0x19e7))or ($bytes_read eq ("")))){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x16f3+ 4093-0x26f0));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x4d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);}}}if (
NXShell::isExitRequestReceivedSIGINT ()){$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});$selector->remove ($readRedis);main::nxclose (
$readRedis);($readRedis=(""));($connected=(0x058b+ 1791-0x0c8a));return ((""));}
}}sub commandDebug{(my $param=shift (@_));(my (@params)=split ( / / ,$param,
(0x1aec+ 2642-0x253e)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.join ($",@params))."\x2e"));(my $command=shift (@params));(my $key=shift (
@params));if (($command eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x0263+ 1039-0x0672));}(my $redisCommand=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d".$command).
"\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62"));if (($key ne (""))){(
$redisCommand.=("\x2c\x6b\x65\x79\x3d".$key));}foreach my $field (@params){(
$redisCommand.=("\x2c\x66\x69\x65\x6c\x64\x3d".$field));}($redisCommand.="\x0a")
;sendToDb ($redisCommand);main::nxwrite (main::nxgetSTDOUT (),(get ()."\x0a"));}
sub commandInfo{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x69\x6e\x66\x6f\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x69\x6e\x66\x6f\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((my (@ready)=$selector->can_read (
(0x2235+ 1980-0x1e39)))){foreach my $fh (@ready){if (($fh eq $readRedis)){my (
$read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));if (((
$bytes_read eq (0x0148+ 1843-0x087b))or ($bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x01d4+ 1356-0x0720));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x49\x6e\x66\x6f\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);closeDb ();
return;}}}}}sub commandScript{(my $param=shift (@_));(my (@params)=split ( / / ,
$param,(0x1504+ 2427-0x1e7f)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x73\x63\x72\x69\x70\x74\x3a\x20"
.join ($",@params))."\x2e"));(my $scriptName=shift (@params));if (($scriptName 
eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x63\x72\x69\x70\x74\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x069f+ 5665-0x1cc0));}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");(my (@args)=());(my $returnValue
=NXRedisScript::executeScript ($scriptName,(\@args),(\@params)));if ((
$scriptName eq 
"\x67\x65\x74\x41\x6c\x6c\x44\x61\x74\x61\x46\x72\x6f\x6d\x53\x65\x74")){(
$returnValue=~ s/^"// );($returnValue=~ s/"$// );(my (@data)=split ( /" "/ ,
$returnValue,(0x0a2c+ 794-0x0d46)));foreach my $singleData (@data){(my (%hash)=
split ( / / ,$singleData,(0x1e5b+ 1132-0x22c7)));foreach my $key (keys (%hash)){
main::nxwrite (main::nxgetSTDOUT (),((($key."\x3a\x20").$hash{$key})."\x0a"));}
main::nxwrite (main::nxgetSTDOUT (),"\x0a");}}else{main::nxwrite (
main::nxgetSTDOUT (),$returnValue);}}sub checkFailCounter{(++$failCounter);if ((
$failCounter==(0x1508+ 4333-0x25f4))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x63\x65\x20\x63\x6f\x6e\x65\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}elsif (($failCounter==(0x14f8+ 543-0x1715))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x77\x69\x63\x65\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}if (($failCounter>(0x0a96+ 6161-0x22a5))){if (($finalizeProcessStarted==
(0x1472+ 4204-0x24dd))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x61\x72\x74\x65\x64\x2e"
));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));main::nxexit ((0x18ff+ 2699-0x238a));}}return;}sub forceCloseRedisClient{(
$connected=(0x0bba+ 5738-0x2223));closeDb ();}sub 
checkFailCounterAndCloseIfNeeded{if (($serverInit==(0x0158+ 1092-0x059b))){
return;}if (($failCounter>(0x0db1+ 1857-0x14f1))){shift (@sendCommandList);
forceCloseRedisClient ();}checkFailCounter ();}sub cleanCommandList{while ((
scalar (@sendCommandList)>(0x0d28+ 4621-0x1f35))){get ();}}sub isSaveDone{(my $response
=shift (@_));if ((($response eq "\x4f\x4b")or ($response eq 
"\x42\x61\x63\x6b\x67\x72\x6f\x75\x6e\x64\x20\x73\x61\x76\x69\x6e\x67\x20\x73\x74\x61\x72\x74\x65\x64"
))){return ((0x1447+ 2045-0x1c43));}return ((0x0006+ 6250-0x1870));}sub 
waitForAllCommands{while ((scalar (@sendCommandList)>(0x106a+ 702-0x1328))){(my $command
=__getCommandNameFromLine ($sendCommandList[(0x023c+ 1174-0x06d2)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command)."\x27\x2e"));get ();}}sub doNotCloseRedisThreadsOnExit{(
$doNotCloseRedisThreadsWhenFreePerl=(0x01db+ 5325-0x16a7));}
NXMsg::register_error ("\x4e\x58\x52\x65\x64\x69\x73",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,(0x0992+ 7926-0x2694));"\x3f\x3f\x3f";
